%global	gem_name	nokogiri

%undefine __brp_mangle_shebangs

Summary:		An HTML, XML, SAX, and Reader parser
Name:			rubygem-%{gem_name}
Version:		1.15.3
Release:		1%{?dist}
License:		MIT and Apache-2.0
URL:			https://nokogiri.org
Source0:		https://rubygems.org/gems/%{gem_name}-%{version}.gem
# created by ./nokogiri-create-full-tarball.sh %%{name} %%{version}
Source1:		rubygem-%{gem_name}-%{version}-full.tar.gz
Patch3000:	%{name}-1.11.0.rc4-shutdown-libxml2-warning.patch
BuildRequires:	ruby-libs, rubygems
BuildRequires:	gcc, libxml2-devel, libxslt-devel, ruby-devel, rubygem-racc
BuildRequires:	rubygem-minitest, rubygems-devel, glibc-all-langpacks, rubygem-rubyzip

Requires:	rubygem-racc
Provides:		bundled(gumbo-parser) = 0.10.1

%description
Nokogiri parses and searches XML/HTML very quickly, and also has
correctly implemented CSS3 selector support as well as XPath support.

Nokogiri also features an Hpricot compatibility layer to help ease the change
to using correct CSS and XPath.

%package	doc
Summary:	Documentation for %{name}
Requires:	%{name} = %{version}-%{release}

%description	doc
This package contains documentation for %{name}.

%package	-n ruby-%{gem_name}
Summary:	Non-Gem support package for %{gem_name}
Requires:	%{name} = %{version}-%{release}
Provides:	ruby(%{gem_name}) = %{version}-%{release}

%description	-n ruby-%{gem_name}
This package provides non-Gem support for %{gem_name}.

%global	version	%{version}



%prep
%setup -q -n %{gem_name}-%{version} -a 1
mv ../%{gem_name}-%{version}.gemspec .

%patch3000 -p1

sed -i \
	-e 's|, "ports/archives/[^"][^"]*"||g' \
	-e 's|, "ports/patches/[^"][^"]*"||g' \
	%{gem_name}-%{version}.gemspec
sed -i -e '\@mini_portile@d' %{gem_name}-%{version}.gemspec

sed -i \
	ext/nokogiri/extconf.rb \
	-e "s@^\(def process_recipe.*\)\$@\1 ; return true@" \
	-e "s@^\(append_cppflags\).*gumbo.*\$@\1(\"-I$(pwd)/gumbo-parser/src\")@" \
	-e "\@libs.*gumbo@s@File\.join.*@\"$(pwd)/gumbo-parser/src/libgumbo.a\"@" \
	-e "\@LIBPATH.*gumbo@s|^\(.*\)\$|# \1|" \
	%{nil}

sed -i \
	gumbo-parser/src/char_ref.c \
	-e '\@^#line [0-9]@s|^\(.*\)$|// \1|'

sed -i \
	gumbo-parser/src/Makefile \
	-e 's|^\(CFLAGS.*=.*\)$|\1 -fPIC|'

env LANG=C.UTF-8 gem build %{gem_name}-%{version}.gemspec



%build
export NOKOGIRI_USE_SYSTEM_LIBRARIES=yes

%set_build_flags
pushd gumbo-parser/src/
make libgumbo.a
popd

%gem_install

chmod 0644 .%{gem_dir}/cache/%{gem_name}-%{version}.gem

find .%{gem_instdir}/lib/ -name '*.jar' -delete
rm -rf .%{gem_instdir}/ext/java



%install
mkdir -p %{buildroot}%{gem_dir}
cp -a ./%{gem_dir}/* %{buildroot}%{gem_dir}

cp -a ./gumbo-parser  %{buildroot}%{gem_instdir}/

find %{buildroot} -name \*.orig_\* | xargs rm -vf

mkdir -p %{buildroot}%{gem_extdir_mri}
cp -a ./%{gem_extdir_mri}/* %{buildroot}%{gem_extdir_mri}/

pushd %{buildroot}
rm -f .%{gem_extdir_mri}/{gem_make.out,mkmf.log}
popd

mkdir -p %{buildroot}%{_bindir}
cp -pa .%{_bindir}/* \
	%{buildroot}%{_bindir}/

for f in $(find %{buildroot}%{gem_instdir} -name \*.rb)
do
	sed -i -e '/^#!/d' $f
	chmod 0644 $f
done

cp -p %{gem_name}-%{version}/[A-Z]* %{buildroot}%{gem_instdir}/

pushd %{buildroot}%{gem_instdir}
rm -rf \
	Gemfile* \
	Rakefile \
	dependencies.yml \
	ext \
	*gemspec \
	patches \
	ports \
	%{nil}
pushd gumbo-parser
rm \
	Makefile \
	%{nil}
find src -type f | \
	grep -v README.md | \
	xargs rm -f

popd
rm -f %{buildroot}%{gem_cache}



%check
export TZ="Asia/Beijing"
LANG=C.UTF-8

cp -a %{gem_name}-%{version}/test/ ./%{gem_instdir}
pushd ./%{gem_instdir}

sed -i test/helper.rb \
	-e '\@require.*simplecov@,\@^end$@s|^|#|'

sed -i '/require..minitest.reporters./ s/^/#/' test/helper.rb
sed -i '/Minitest::Reporters/ s/^/#/' test/helper.rb

%ifarch ppc64le
export NOKOGIRI_TEST_GC_LEVEL=major
%endif

env \
	RUBYLIB=".:lib:test:%{buildroot}%{gem_extdir_mri}" \
	ruby \
	-e \
	"require 'test/helper' ; Dir.glob('test/**/test_*.rb'){|f| require f}" || \
	exit 1

for f in $SKIPTEST
do
	mv $f.skip $f
done

popd



%files
%{_bindir}/%{gem_name}
%{gem_extdir_mri}/
%dir	%{gem_instdir}/
%doc	%{gem_instdir}/[A-Z]*
%{gem_instdir}/bin/
%{gem_instdir}/lib/
%dir	%{gem_instdir}/gumbo-parser
%dir	%{gem_instdir}/gumbo-parser/src
%doc	%{gem_instdir}/gumbo-parser/[A-Z]*
%doc	%{gem_instdir}/gumbo-parser/src/README.md
%{gem_dir}/specifications/%{gem_name}-%{version}.gemspec

%files	doc
%defattr(-,root,root,-)
%{gem_dir}/doc/%{gem_name}-%{version}/



%changelog
* Fri Jul 14 2023 Shuo Wang <abushwang@tencent.com> - 1.15.3-1
- update to 1.15.3

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.14.1-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.14.1-2
- Rebuilt for OpenCloudOS Stream 23

* Mon Feb 13 2023 Zhao Zhen <jeremiazhao@tencent.com> - 1.14.1-1
- 1.14.1
